#!/usr/bin/env python

###############################################################################
#
# $Id: $
# Take a snapshot of requests for all library managers 
###############################################################################
import time
import os

import enstore_functions2
import e_errors
import configuration_client

if __name__ == "__main__":

    default_config_host = enstore_functions2.default_host()
    default_config_port = enstore_functions2.default_port()
    csc = configuration_client.ConfigurationClient((default_config_host,
                                                    default_config_port))

    rc = csc.dump_and_save()
    inquisitor = csc.saved_dict.get("inquisitor")
    web_dir = inquisitor.get("html_file", None)
    if not web_dir:
        print "Destination directory is not defined"
        sys.exit(1)
    current_time = time.time()
    tm = time.localtime(current_time)
    dname = "%04d-%02d-%02d" % (tm[0], tm[1], tm[2])
    suffix = "%02d-%02d"%(tm[3], tm[4])
    history_dir = os.path.join(web_dir, "request_history", dname)
    print inquisitor 
    library_managers = []
    lm_dirs = []
    for key in csc.saved_dict.keys():
        if key.find(".library_manager") > 0:
            library_managers.append(key)
            lm_dirs.append(os.path.join(history_dir,key))
            
    for lm_path in lm_dirs:
        if not os.path.exists(lm_path):
            try:
                os.makedirs(lm_path)
            except os.error, msg:
                print "Can not create %s. %s"%(lm_path, msg)
                sys.exit(1)
    for lm_path in lm_dirs:
        src = "%s/%s-%s"%(web_dir, os.path.basename(lm_path), "full.html")
        mtime = 0
        try:
            mtime = os.path.getmtime(src)
        except:
            pass
        if mtime:
            tm = time.localtime()
            suffix = "%02d-%02d"%(tm[3], tm[4])
        dst = "%s/%s-%s.%s"%(lm_path, os.path.basename(lm_path), suffix, "html")
        if not os.path.exists(dst):
            # copy src
            rc = os.system("cp %s %s"%(src,dst))
            print "RC", rc
        print src, dst
        
        
        #null1.library_manager-full.html

    
            
        
            
        
